/* ̧قDoxygenpɏĂ܂B*/
/*! \file *********************************************************************
 *
 * \brief
 * PID䕔ͯ ̧
 *
 * ̧قPID䕔Ɋւ`A^`A^錾܂݂܂B
 *
 * \par Application note:
 * AVR447: ATmega48/88/168gp3ivӰ̐쓮
 *
 * \par Documentation
 * IȺގAxׁ߲A߲אݒAx޲ɂĂreadme.html
 * B
 *
 * \author
 * Atmel Corporation: http://www.atmel.com \n
 * xEҰ: avr@atmel.com
 *
 * $Name: RELEASE_1_0 $
 * $Revision: 1.3 $
 * $RCSfile: pid.h,v $
 * $Date: 2006/03/16 11:57:20 $  \n
 ******************************************************************************/

#ifndef PID_H
#define PID_H

/*! \brief PIDpkڌW
 *
 * PIDpkڌWBP,I,D͂̐lɂďZ܂B
 */
#define SCALING_FACTOR	256

/*! \brief PID
 *
 * PIDZ@ɂĎgpݒ_ް
 */
typedef struct pidData{
  int16_t lastProcessValue;			//! l̔T̂ɗpAŌ̏l
  int32_t sumError;					//! ϕvZɎgpA덷̑a
  int16_t P_Factor;					//! gWŏZ(~100)ꂽAᒲ萔
  int16_t I_Factor;					//! gWŏZ(~100)ꂽAϕ萔
  int16_t D_Factor;					//! gWŏZ(~100)ꂽA萔
  int16_t maxError;					//! 邽߂́Aő勖e덷
  int32_t maxSumError;				//! 邽߂́Aő勖ea덷
} pidData_t;

#define MAX_INT		32767			//! Px^ől
#define MAX_LONG	2147483647L		//! {x^ől

/*! ϕ̍ől
 *
 * ͐ϕ̐܂͕̍ől𐧌܂B̒l̕ύX͍ϕ
 * 𓱂܂B̒l͊ɌƂȂް^̏̂߁A肩炱̒l𑝂₵
 * Ă͂܂B
 */
#define MAX_I_TERM	(MAX_LONG - (2 * (int32_t)MAX_INT))

// _l
#define FALSE		0				//! FALSE萔
#define TRUE		(!FALSE)		//! TRUE萔

// ֐^錾
void PID_Init(int16_t p_factor, int16_t i_factor, int16_t d_factor, pidData_t *pid);
int16_t PID_Controller(int16_t setPoint, int16_t processValue, pidData_t *pid_st);
void PID_Reset_Integrator(pidData_t *pid_st);

#endif
